with Apex_Occurrence_Types;
with System;
with Unchecked_Conversion;
with Apex_Stack_Trace_Types;

package Apex_Occurrence_Utils is

    use Apex_Occurrence_Types;

    function Traceback_Regs_Get
                (Occurrence : Exception_Occurrence_Access)
                return Apex_Stack_Trace_Types.Traceback_Regs_Rec_Access;
    pragma Suppress (Elaboration_Check, On => Traceback_Regs_Get);

    function Next_Get (Occurrence : Exception_Occurrence_Access)
                      return Exception_Occurrence_Access;
    pragma Suppress (Elaboration_Check, On => Next_Get);

    function To_Exception_Occurrence_Access is
       new Unchecked_Conversion (System.Address, Exception_Occurrence_Access);

    function Exception_Name
                (Occurrence : Exception_Occurrence_Access) return String;
    pragma Suppress (Elaboration_Check, On => Exception_Name);

    function Exception_Message
                (Occurrence : Exception_Occurrence_Access) return String;
    pragma Suppress (Elaboration_Check, On => Exception_Message);

    procedure Exception_Information_Callout_Install (Func : System.Address);
    pragma Suppress (Elaboration_Check,
                     On => Exception_Information_Callout_Install);


end Apex_Occurrence_Utils;

