with Unchecked_Conversion;
with Ada.Exceptions;
with Ada.Exceptions.Stack_Trace_Utils;
with V_I_Except;

package body Apex_Occurrence_Utils is

    pragma Suppress_All;

    function To_Ae_Exception_Occurrence_Access is
       new Unchecked_Conversion (Exception_Occurrence_Access,
                                 Ada.Exceptions.Exception_Occurrence_Access);

    function Traceback_Regs_Get (Occurrence : Exception_Occurrence_Access)
                                return Apex_Stack_Trace_Types.
                                       Traceback_Regs_Rec_Access is
    begin
        return Apex_Stack_Trace_Types.To_Traceback_Regs_Rec_Access
                  (V_I_Except.Exception_Occurrence_Traceback_Regs
                      (V_I_Except.To_Exception_Occurrence_Access
                          (Occurrence.all'Address)));
    end Traceback_Regs_Get;


    function Next_Get (Occurrence : Exception_Occurrence_Access)
                      return Exception_Occurrence_Access is
    begin
        return Apex_Occurrence_Types.To_Exception_Occurrence_Access
                  (V_I_Except.Exception_Occurrence_Next
                      (V_I_Except.To_Exception_Occurrence_Access
                          (Occurrence.all'Address)).all'Address);
    end Next_Get;


    function Exception_Name
                (Occurrence : Exception_Occurrence_Access) return String is
    begin
        return Ada.Exceptions.Exception_Name (Occurrence.all);
    end Exception_Name;


    function Exception_Message
                (Occurrence : Exception_Occurrence_Access) return String is
    begin
        return Ada.Exceptions.Exception_Message (Occurrence.all);
    end Exception_Message;


    procedure Exception_Information_Callout_Install (Func : System.Address) is
    begin
        Ada.Exceptions.Stack_Trace_Utils.Exception_Information_Callout_Install
           (Func);
    end Exception_Information_Callout_Install;


end Apex_Occurrence_Utils;
