with Apex_Occurrence_Types;
with Apex_Stack_Trace_Types;

package Apex_Stack_Trace is

    use Apex_Stack_Trace_Types;

    -- This function must called before an exception is raised in order for
    -- stack tracing to work from an exception occurrence.
    procedure Exception_Trace_Enable;
    pragma Suppress (Elaboration_Check, On => Exception_Trace_Enable);

    procedure Trace_Dump (Occurrence :
                             Apex_Occurrence_Types.Exception_Occurrence;
                          Filename : String := "trace_dump";
                          Append : Boolean := False;
                          Trace_Label : String := "");

    procedure Trace_Dump (Occurrence :
                             Apex_Occurrence_Types.Exception_Occurrence_Access;
                          Filename : String := "trace_dump";
                          Append : Boolean := False;
                          Trace_Label : String := "");

    procedure Trace_Dump (Filename : String := "trace_dump";
                          Append : Boolean := False;
                          Trace_Label : String := "trace");


    procedure Trace_Dump (Context : Interrupt_Context_Access;
                          Filename : String := "trace_dump";
                          Append : Boolean := False;
                          Trace_Label : String := "interrupt_trace");
    pragma Suppress (Elaboration_Check, On => Trace_Dump);

    -- Cause a core dump if an unhandled exception occurs.  This is useful
    -- for doing post-mortem analysis via the debugger.  Note that we don't
    -- (yet) support core dumps on the cross.

    procedure Unhandled_Exception_Core_Dump_Enable;
    pragma Suppress (Elaboration_Check,
                     On => Unhandled_Exception_Core_Dump_Enable);

    procedure Unhandled_Exception_Core_Dump_Disable;
    pragma Suppress (Elaboration_Check,
                     On => Unhandled_Exception_Core_Dump_Disable);


end Apex_Stack_Trace;

