with Apex_Occurrence_Types;
with Apex_Occurrence_Utils;

package body Apex_Stack_Trace_Foundation is

    pragma Suppress_All;


    procedure Initialize (User_Frame : Frame_Access;
                          From_Occurrence : Apex_Occurrence_Types.
                                               Exception_Occurrence_Access) is
        procedure Initialize (User_Frame : Frame_Access;
                              Traceback_Regs : Apex_Stack_Trace_Types.
                                                  Traceback_Regs_Rec_Access);
        pragma Interface (Ada, Initialize);
        pragma Interface_Name (Initialize,
                               "__APEX_INIT_FRAME_FROM_TRACEBACK_REGS");
    begin
        Initialize (User_Frame, Apex_Occurrence_Utils.Traceback_Regs_Get
                                   (From_Occurrence));
    end Initialize;


    procedure Initialize (User_Frame : Frame_Access;
                          From_Occurrence : Apex_Occurrence_Types.
                                               Exception_Occurrence) is
    begin
        Initialize (User_Frame, Apex_Occurrence_Utils.
                                   To_Exception_Occurrence_Access
                                   (From_Occurrence'Address));
    end Initialize;


    function Next_Occurrence
                (Occurrence : Apex_Occurrence_Types.
                                 Exception_Occurrence_Access)
                return Apex_Occurrence_Types.Exception_Occurrence_Access is
    begin
        return Apex_Occurrence_Utils.Next_Get (Occurrence);
    end Next_Occurrence;


    function Next_Occurrence (Occurrence :
                                 Apex_Occurrence_Types.Exception_Occurrence)
                             return Apex_Occurrence_Types.
                                    Exception_Occurrence_Access is
    begin
        return Apex_Occurrence_Utils.Next_Get
                  (Apex_Occurrence_Utils.To_Exception_Occurrence_Access
                      (Occurrence'Address));

    end Next_Occurrence;

end Apex_Stack_Trace_Foundation;

